Index: /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/iom_mpp.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/iom_mpp.f90	(revision 5074)
+++ /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/iom_mpp.f90	(revision 5075)
@@ -6,36 +6,81 @@
 !
 ! DESCRIPTION:
-!> @brief massively parallel processing Input/Output manager :  
-!> Library to read/write mpp files<br/>
+!> @brief This module manage massively parallel processing Input/Output manager.
+!> Library to read/write mpp files.
 !>
 !> @details
-!> 
 !>    to open mpp files (only file to be used (see mpp_get_use) 
 !>    will be open):<br/>
+!> @code
 !>    CALL iom_mpp_open(td_mpp)
+!> @endcode
 !>       - td_mpp is a mpp structure
 !>
 !>    to creates mpp files:<br/>
+!> @code
 !>    CALL iom_mpp_create(td_mpp)
+!> @endcode
 !>       - td_mpp is a mpp structure
 !>
 !>    to write in mpp files :<br/>
+!> @code
 !>    CALL  iom_mpp_write_file(td_mpp)
+!> @endcode
 !>       - td_mpp is a mpp structure
 !>
 !>    to close mpp files:<br/>
+!> @code
 !>    CALL iom_mpp_close(td_mpp)
+!> @endcode
 !>
 !>    to read one variable in an mpp files:<br/>
-!>    - tl_var=iom_mpp_read_var( td_mpp, id_varid, [td_dom,] [ld_border] ) 
-!>    - tl_var=iom_mpp_read_var( td_mpp, [cd_name,] [td_dom,] [ld_border,] [cd_stdname] ) 
+!> @code
+!>    tl_var=iom_mpp_read_var( td_mpp, id_varid, [id_start, id_count] [,id_ew] ) 
+!> @endcode
+!>    or
+!> @code
+!>    tl_var=iom_mpp_read_var( td_mpp, cd_name, [id_start, id_count] [,id_ew] ) 
+!> @endcode
 !>       - td_mpp is a mpp structure
 !>       - id_varid is a variable id
-!>       - td_dom is a domain structure (optional, can't be used with ld_border)
-!>       - ld_border is true if we want to read border of global domain only
-!>       (optional, can't be used with td_dom)
-!>       - cd_name is variable name (optional, cd_name and/or cd_stdname should be specify.)
-!>       - cd_stdname is variable standard name (optional, cd_name and/or cd_stdname should be specify.)
-!>
+!>       - cd_name is variable name or standard name
+!>       - id_start is a integer(4) 1D array of index from which the data 
+!>          values will be read [optional]
+!>       - id_count is a integer(4) 1D array of the number of indices selected
+!>          along each dimension [optional]
+!>       - id_ew East West overlap [optional]
+!>
+!>    to fill variable value in mpp structure:<br/>
+!> @code
+!>    CALL iom_mpp_fill_var(td_mpp, id_varid, [id_start, id_count] [,id_ew] )
+!> @endcode
+!>    or<br/>
+!> @code
+!>    CALL iom_mpp_fill_var(td_mpp, cd_name, [id_start, id_count] [,id_ew] )
+!> @endcode
+!>       - td_mpp is mpp structure
+!>       - id_varid is variable id
+!>       - cd_name is variable name or standard name
+!>       - id_start is a integer(4) 1D array of index from which the data 
+!>          values will be read [optional]
+!>       - id_count is a integer(4) 1D array of the number of indices selected
+!>          along each dimension [optional]
+!>       - id_ew East West overlap [optional]
+!>
+!>    to fill all variable in mpp structure:<br/>
+!> @code
+!>    CALL iom_mpp_fill_var(td_mpp, [id_start, id_count] [,id_ew] )
+!> @endcode
+!>       - td_mpp is mpp structure
+!>       - id_start is a integer(4) 1D array of index from which the data 
+!>          values will be read [optional]
+!>       - id_count is a integer(4) 1D array of the number of indices selected
+!>          along each dimension [optional]
+!>       - id_ew East West overlap
+!>
+!>    to write files composong mpp strucutre:<br/>
+!> @code
+!>    CALL iom_mpp_write_file(td_mpp) 
+!> @endcode
 !>
 !> @author
@@ -43,19 +88,13 @@
 ! REVISION HISTORY:
 !> @date Nov, 2013 - Initial Version
-!
+!>
 !> @note Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
-!> @todo
-!> - add read var with start and count as in iom
-!> - add iom_mpp_fill_var_value : cf iom_fill_var_value 
-!> - not so easy to use that it should be, have to work on it
-!> - improve mpp init
-!> - improve mpp_get_use
-!> - imporve dom_init
 !----------------------------------------------------------------------
 MODULE iom_mpp
    USE netcdf                          ! nf90 library
+   USE global                          ! global parameter
    USE kind                            ! F90 kind parameter
    USE fct                             ! basic useful function
-   USE logger                             ! log file manager
+   USE logger                          ! log file manager
    USE dim                             ! dimension manager
    USE att                             ! attribute manager
@@ -64,41 +103,27 @@
    USE iom                             ! I/O manager
    USE mpp                             ! mpp manager
-   USE dom                             ! domain manager
    IMPLICIT NONE
-   PRIVATE
    ! NOTE_avoid_public_variables_if_possible
 
    ! function and subroutine
-   PUBLIC :: iom_mpp_open                    !< open files composing mpp structure to be used
-   PUBLIC :: iom_mpp_create                  !< creates files composing mpp structure to be used
+   PUBLIC :: iom_mpp_open                    !< open all files composing mpp structure
+   PUBLIC :: iom_mpp_create                  !< creates files composing mpp structure
    PUBLIC :: iom_mpp_close                   !< close file composing mpp structure
    PUBLIC :: iom_mpp_read_var                !< read one variable in an mpp structure
-   PUBLIC :: iom_mpp_fill_var                !< fill variable value in mpp structure
    PUBLIC :: iom_mpp_write_file              !< write mpp structure in files
 
-   PRIVATE :: iom_mpp__read_var_id           !< read one variable in an mpp structure, given variable id
-   PRIVATE :: iom_mpp__read_var_name         !< read one variable in an mpp structure, given variable name
-   PRIVATE :: iom_mpp__read_var_value        !< read variable value in an mpp structure
-   PRIVATE :: iom_mpp__no_pole_no_overlap    !< do not overlap north fold boundary or east-west boundary
-   PRIVATE :: iom_mpp__no_pole_cyclic        !< do not overlap north fold boundary. However uses cyclic east-west boundary
-   PRIVATE :: iom_mpp__no_pole_overlap       !< do not overlap north fold boundary. However overlaps east-west boundary
-!   PRIVATE :: iom_mpp__pole_no_overlap       !< overlaps north fold boundary. However do not overlap east-west boundary
-!   PRIVATE :: iom_mpp__pole_cyclic           !< overlaps north fold boundary and uses cyclic east-west boundary
-!   PRIVATE :: iom_mpp__pole_overlap          !< overlaps north fold boundary and east-west boundary
-
-   INTERFACE iom_mpp_read_var                   !< read one variable in an mpp structure
-      MODULE PROCEDURE iom_mpp__read_var_id     !< given variable id
-      MODULE PROCEDURE iom_mpp__read_var_name   !< given variable name 
+   PRIVATE :: iom_mpp__read_var_id           ! read one variable in an mpp structure, given variable id
+   PRIVATE :: iom_mpp__read_var_name         ! read one variable in an mpp structure, given variable name
+   PRIVATE :: iom_mpp__read_var_value        ! read variable value in an mpp structure
+
+   INTERFACE iom_mpp_read_var                   ! read one variable in an mpp structure
+      MODULE PROCEDURE iom_mpp__read_var_id     ! given variable id
+      MODULE PROCEDURE iom_mpp__read_var_name   ! given variable name 
    END INTERFACE iom_mpp_read_var
 
-   INTERFACE iom_mpp_fill_var                !< fill variable value in an mpp structure
-      MODULE PROCEDURE iom_mpp__fill_var_id   !< given variable id
-      MODULE PROCEDURE iom_mpp__fill_var_name !< given variable name
-      MODULE PROCEDURE iom_mpp__fill_var_all  !< fill all variable
-   END INTERFACE iom_mpp_fill_var
-
 CONTAINS
    !-------------------------------------------------------------------
-   !> @brief This subroutine open files composing mpp structure to be used<br/>
+   !> @brief This subroutine open files composing mpp structure to be used.
+   !> @details
    !> If try to open a file in write mode that did not exist, create it.<br/>
    !> 
@@ -112,13 +137,14 @@
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_mpp : mpp structure
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE iom_mpp_open(td_mpp)
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_mpp mpp structure
+   !-------------------------------------------------------------------
+   SUBROUTINE iom_mpp_open(td_mpp, id_perio, id_ew)
       IMPLICIT NONE
       ! Argument      
-      TYPE(TMPP), INTENT(INOUT)  :: td_mpp
+      TYPE(TMPP) , INTENT(INOUT)  :: td_mpp
+      INTEGER(i4), INTENT(IN), OPTIONAL :: id_perio
+      INTEGER(i4), INTENT(IN), OPTIONAL :: id_ew
 
       ! local variable
@@ -135,59 +161,68 @@
 
       ELSE
-         IF( ANY(td_mpp%t_proc(:)%l_use) )THEN
-
-            ! add suffix to mpp name
-            td_mpp%c_name=file_add_suffix( TRIM(td_mpp%c_name), &
-                                         & TRIM(td_mpp%c_type) )
-
-            td_mpp%t_proc(:)%c_type=TRIM(td_mpp%c_type) 
-            IF( td_mpp%i_nproc > 1 )THEN
-               DO ji=1,td_mpp%i_nproc
-                  IF( td_mpp%t_proc(ji)%l_use )THEN
-
+         ! if no processor file selected
+         ! force to open all files 
+         IF( .NOT. ANY( td_mpp%t_proc(:)%l_use ) )THEN
+            td_mpp%t_proc(:)%l_use=.TRUE.
+         ENDIF
+
+         ! add suffix to mpp name
+         td_mpp%c_name=file_add_suffix( TRIM(td_mpp%c_name), &
+                                      & TRIM(td_mpp%c_type) )
+
+         td_mpp%t_proc(:)%c_type=TRIM(td_mpp%c_type) 
+         IF( td_mpp%i_nproc > 1 )THEN
+            DO ji=1,td_mpp%i_nproc
+               IF( td_mpp%t_proc(ji)%l_use )THEN
+
+                  SELECT CASE(TRIM(td_mpp%c_type))
+                  CASE('cdf')
+                     cl_name=TRIM( file_rename(td_mpp%c_name, ji-1) )
+                  CASE('dimg')
                      cl_name=TRIM( file_rename(td_mpp%c_name, ji) )
-                     td_mpp%t_proc(ji)%c_name=TRIM(cl_name)
-
-                     CALL iom_open(td_mpp%t_proc(ji))
-
-                  ENDIF
-               ENDDO
-            ELSE ! td_mpp%i_nproc == 1 
-                  cl_name=TRIM( file_rename(td_mpp%c_name) )
-                  td_mpp%t_proc(1)%c_name=TRIM(cl_name)
-
-                  CALL iom_open(td_mpp%t_proc(1))
-            ENDIF
-
-         ELSE
-
-            IF( ANY(td_mpp%t_proc(:)%l_ctr) )THEN
-
-               CALL logger_warn("IOM MPP OPEN: open file on border")
-               DO ji=1,td_mpp%i_nproc
-                  IF( td_mpp%t_proc(ji)%l_ctr )THEN
-                     CALL iom_open(td_mpp%t_proc(ji))
-                  ENDIF
-               ENDDO
-
-            ELSE
-               CALL logger_error( " IOM MPP OPEN: no processor to be used.")
-               CALL logger_debug( " use mpp_get_use before running iom_mpp_open")
-            ENDIF
-         ENDIF
+                  CASE DEFAULT
+                     CALL logger_fatal("IOM MPP OPEN: can not open file "//&
+                     &  "of type "//TRIM(td_mpp%c_type))
+                  END SELECT
+
+                  td_mpp%t_proc(ji)%c_name=TRIM(cl_name)
+
+                  CALL iom_open(td_mpp%t_proc(ji))
+
+               ENDIF
+            ENDDO
+         ELSE ! td_mpp%i_nproc == 1 
+               cl_name=TRIM( file_rename(td_mpp%c_name) )
+               td_mpp%t_proc(1)%c_name=TRIM(cl_name)
+
+               CALL iom_open(td_mpp%t_proc(1))
+         ENDIF
+
+         IF( PRESENT(id_ew) )THEN
+            td_mpp%i_ew=id_ew
+            ! add east west overlap to each variable
+            DO ji=1,td_mpp%i_nproc
+               WHERE(td_mpp%t_proc(ji)%t_var(:)%t_dim(1)%l_use)
+                  td_mpp%t_proc(ji)%t_var(:)%i_ew=td_mpp%i_ew
+               ENDWHERE
+            ENDDO
+         ENDIF
+
+         IF( PRESENT(id_perio) )THEN
+            td_mpp%i_perio=id_perio
+         ENDIF
+
       ENDIF
 
    END SUBROUTINE iom_mpp_open
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This subroutine create files, composing mpp structure to be used,
-   !> in write mode<br/>
+   !> in write mode.
    !> 
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_mpp : mpp structure
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_mpp mpp structure
+   !-------------------------------------------------------------------
    SUBROUTINE iom_mpp_create(td_mpp)
       IMPLICIT NONE
@@ -209,14 +244,12 @@
 
    END SUBROUTINE iom_mpp_create
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This subroutine close files composing mpp structure.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_mpp : mpp structure
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_mpp mpp structure
+   !-------------------------------------------------------------------
    SUBROUTINE iom_mpp_close(td_mpp)
       IMPLICIT NONE
@@ -239,35 +272,36 @@
             ENDIF
          ENDDO
+         td_mpp%t_proc(:)%l_use=.FALSE.
       ENDIF
 
    END SUBROUTINE iom_mpp_close
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This function read variable value in opened mpp files,
-   !> given variable id.</br/>
+   !> given variable id.
    !>
    !> @details
-   !> If domain is given, read only domain.
-   !> If border is .TRUE., read only border processor   
-   !>
-   !
+   !> Optionally start indices and number of point to be read could be specify.
+   !> as well as East West ovelap of the global domain.
+   !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_mpp : mpp structure
-   !> @param[in] id_varid : variable id
-   !> @param[in] td_dom : domain structure
-   !> @param[in] ld_border : read only border
+   !> - November, 2013- Initial Version
+   !> @date October, 2014
+   !> - use start and count array instead of domain structure.
+   !>
+   !> @param[in] td_mpp    mpp structure
+   !> @param[in] id_varid  variable id
+   !> @param[in] id_start  index in the variable from which the data values 
+   !> will be read
+   !> @param[in] id_count  number of indices selected along each dimension
    !> @return  variable structure 
    !-------------------------------------------------------------------
-   !> @code
    TYPE(TVAR) FUNCTION iom_mpp__read_var_id(td_mpp, id_varid,&
-   &                                        td_dom, ld_border)
+   &                                        id_start, id_count)
       IMPLICIT NONE
       ! Argument      
-      TYPE(TMPP),    INTENT(IN) :: td_mpp
-      INTEGER(i4),   INTENT(IN) :: id_varid
-      TYPE(TDOM) ,   INTENT(IN), OPTIONAL :: td_dom
-      LOGICAL,       INTENT(IN), OPTIONAL :: ld_border
+      TYPE(TMPP),                INTENT(IN) :: td_mpp
+      INTEGER(i4),               INTENT(IN) :: id_varid
+      INTEGER(i4), DIMENSION(:), INTENT(IN), OPTIONAL :: id_start
+      INTEGER(i4), DIMENSION(:), INTENT(IN), OPTIONAL :: id_count      
 
       ! local variable
@@ -288,9 +322,9 @@
             IF( il_ind(1) /= 0 )THEN
 
-               iom_mpp__read_var_id=td_mpp%t_proc(1)%t_var(il_ind(1))
+               iom_mpp__read_var_id=var_copy(td_mpp%t_proc(1)%t_var(il_ind(1)))
 
                !!! read variable value
                CALL iom_mpp__read_var_value(td_mpp, iom_mpp__read_var_id, &
-               &                            td_dom, ld_border)
+               &                            id_start, id_count)
 
             ELSE
@@ -308,13 +342,12 @@
 
    END FUNCTION iom_mpp__read_var_id
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This function read variable value in opened mpp files, 
-   !> given variable name or standard name.</br/>
+   !> given variable name or standard name.
+   !>
    !> @details
-   !> If domain is given, read only domain.
-   !> If border is .TRUE., read only border processor
-   !
-   !> @details
+   !> Optionally start indices and number of point to be read could be specify.
+   !> as well as East West ovelap of the global domain.
+   !>
    !> look first for variable name. If it doesn't
    !> exist in file, look for variable standard name.<br/>
@@ -322,24 +355,26 @@
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_mpp : mpp structure
-   !> @param[in] cd_name : variable name
-   !> @param[in] td_dom : domain structure
-   !> @param[in] ld_border : read only border 
+   !> - November, 2013- Initial Version
+   !> @date October, 2014
+   !> - use start and count array instead of domain structure.
+   !
+   !> @param[in] td_mpp    mpp structure
+   !> @param[in] cd_name   variable name
+   !> @param[in] id_start  index in the variable from which the data values 
+   !> will be read
+   !> @param[in] id_count  number of indices selected along each dimension
    !> @return  variable structure 
    !-------------------------------------------------------------------
-   !> @code
    TYPE(TVAR) FUNCTION iom_mpp__read_var_name(td_mpp, cd_name,    &
-   &                                          td_dom, ld_border   )
+   &                                          id_start, id_count )
       IMPLICIT NONE
       ! Argument      
-      TYPE(TMPP),       INTENT(IN) :: td_mpp
-      CHARACTER(LEN=*), INTENT(IN) :: cd_name
-      TYPE(TDOM) ,      INTENT(IN), OPTIONAL :: td_dom
-      LOGICAL,          INTENT(IN), OPTIONAL :: ld_border
+      TYPE(TMPP),                INTENT(IN) :: td_mpp
+      CHARACTER(LEN=*),          INTENT(IN) :: cd_name
+      INTEGER(i4), DIMENSION(:), INTENT(IN), OPTIONAL :: id_start
+      INTEGER(i4), DIMENSION(:), INTENT(IN), OPTIONAL :: id_count      
 
       ! local variable
-      INTEGER(i4)       :: il_varid
+      INTEGER(i4)       :: il_ind
       !----------------------------------------------------------------
       ! check if mpp exist
@@ -351,13 +386,13 @@
       ELSE
 
-            il_varid=var_get_id( td_mpp%t_proc(1)%t_var(:), cd_name)
-            IF( il_varid /= 0 )THEN
-
-               iom_mpp__read_var_name=td_mpp%t_proc(1)%t_var(il_varid)
+            il_ind=var_get_index( td_mpp%t_proc(1)%t_var(:), cd_name)
+            IF( il_ind /= 0 )THEN
+
+               iom_mpp__read_var_name=var_copy(td_mpp%t_proc(1)%t_var(il_ind))
 
                !!! read variable value
                CALL iom_mpp__read_var_value( td_mpp, &
                &                             iom_mpp__read_var_name, &
-               &                             td_dom, ld_border)
+               &                             id_start, id_count)
 
             ELSE
@@ -372,174 +407,4 @@
       
    END FUNCTION iom_mpp__read_var_name
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine fill all variable value in opened mpp files,
-   !> given variable id.</br/>
-   !>
-   !> @details
-   !> If domain is given, read only domain.
-   !> If border is .TRUE., read only border processor   
-   !> 
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_mpp : mpp structure
-   !> @param[in] td_dom : domain structure
-   !> @param[in] ld_border : read only border
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE iom_mpp__fill_var_all(td_mpp, td_dom, ld_border)
-      IMPLICIT NONE
-      ! Argument      
-      TYPE(TMPP),    INTENT(INOUT) :: td_mpp
-      TYPE(TDOM) ,   INTENT(IN),   OPTIONAL :: td_dom
-      LOGICAL,       INTENT(IN),   OPTIONAL :: ld_border
-
-      ! local variable
-
-      ! loop indices
-      INTEGER(i4) :: ji
-      !----------------------------------------------------------------
-      ! check if mpp exist
-      IF( .NOT. ASSOCIATED(td_mpp%t_proc) )THEN
-
-         CALL logger_error( " IOM MPP FILL VAR : domain decomposition not define "//&
-         &               " in mpp strcuture "//TRIM(td_mpp%c_name))
-
-      ELSE
-
-         DO ji=1,td_mpp%t_proc(1)%i_nvar
-            CALL iom_mpp_fill_var(td_mpp, ji, td_dom, ld_border )
-         ENDDO
-
-      ENDIF
-
-   END SUBROUTINE iom_mpp__fill_var_all
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine fill variable value in opened mpp files,
-   !> given variable id.</br/>
-   !>
-   !> @details
-   !> If domain is given, read only domain.
-   !> If border is .TRUE., read only border processor   
-   !> 
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_mpp : mpp structure
-   !> @param[in] id_varid : variable id
-   !> @param[in] td_dom : domain structure
-   !> @param[in] ld_border : read only border
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE iom_mpp__fill_var_id(td_mpp, id_varid, td_dom, ld_border)
-      IMPLICIT NONE
-      ! Argument      
-      TYPE(TMPP),    INTENT(INOUT) :: td_mpp
-      INTEGER(i4),   INTENT(IN)    :: id_varid
-      TYPE(TDOM) ,   INTENT(IN),   OPTIONAL :: td_dom
-      LOGICAL,       INTENT(IN),   OPTIONAL :: ld_border
-
-      ! local variable
-      INTEGER(i4), DIMENSION(1) :: il_ind
-      !----------------------------------------------------------------
-      ! check if mpp exist
-      IF( .NOT. ASSOCIATED(td_mpp%t_proc) )THEN
-
-         CALL logger_error( " IOM MPP FILL VAR: domain decomposition not define "//&
-         &               " in mpp strcuture "//TRIM(td_mpp%c_name))
-
-      ELSE
-
-         IF( ANY(td_mpp%t_proc(:)%i_id /= 0) )THEN
-            ! look for variable id
-            il_ind(:)=MINLOC( td_mpp%t_proc(1)%t_var(:)%i_id, &
-            &           mask=(td_mpp%t_proc(1)%t_var(:)%i_id==id_varid))
-            IF( il_ind(1) /= 0 )THEN
-
-               !!! read variable value
-               CALL iom_mpp__read_var_value( td_mpp, &
-               &                     td_mpp%t_proc(1)%t_var(il_ind(1)), &
-               &                     td_dom, ld_border)
-
-            ELSE
-               CALL logger_error( &
-               &  " IOM MPP FILL VAR : there is no variable with id "//&
-               &  TRIM(fct_str(id_varid))//" in processor/file "//&
-               &  TRIM(td_mpp%t_proc(1)%c_name))
-            ENDIF
-         ELSE
-            CALL logger_error(" IOM MPP FILL VAR : can't read variable, mpp "//&
-            &  TRIM(td_mpp%c_name)//" not opened")
-         ENDIF
-
-      ENDIF
-
-   END SUBROUTINE iom_mpp__fill_var_id
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine fill variable value in opened mpp files, 
-   !> given variable name or standard name.</br/>
-   !> @details
-   !> If domain is given, read only domain.
-   !> If border is .TRUE., read only border processor   
-   !
-   !> @details
-   !> look first for variable name. If it doesn't
-   !> exist in file, look for variable standard name.<br/>
-   !> If variable name is not present, check variable standard name.<br/>
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_mpp : mpp structure
-   !> @param[in] cd_name : variable name or standard name
-   !> @param[in] td_dom : domain structure
-   !> @param[in] ld_border : read only border 
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE iom_mpp__fill_var_name(td_mpp, cd_name, td_dom, ld_border )
-      IMPLICIT NONE
-      ! Argument      
-      TYPE(TMPP),       INTENT(INOUT) :: td_mpp
-      CHARACTER(LEN=*), INTENT(IN   ) :: cd_name
-      TYPE(TDOM) ,      INTENT(IN   ), OPTIONAL :: td_dom
-      LOGICAL,          INTENT(IN   ), OPTIONAL :: ld_border
-
-      ! local variable
-      INTEGER(i4)       :: il_ind
-      !----------------------------------------------------------------
-      ! check if mpp exist
-      IF( .NOT. ASSOCIATED(td_mpp%t_proc) )THEN
-
-         CALL logger_error( " IOM MPP FILL VAR : domain decomposition not define "//&
-         &               " in mpp strcuture "//TRIM(td_mpp%c_name))
-
-      ELSE
-
-            il_ind=var_get_id( td_mpp%t_proc(1)%t_var(:), cd_name, cd_name)
-            IF( il_ind /= 0 )THEN
-
-               !!! read variable value
-               CALL iom_mpp__read_var_value(td_mpp, &
-               &                    td_mpp%t_proc(1)%t_var(il_ind), &
-               &                    td_dom, ld_border)
-
-            ELSE
-
-               CALL logger_error( &
-               &  " IOM MPP FILL VAR : there is no variable with "//&
-               &  "name or standard name "//TRIM(cd_name)//&
-               &  " in processor/file "//TRIM(td_mpp%t_proc(1)%c_name))
-
-            ENDIF
-
-      ENDIF
-      
-   END SUBROUTINE iom_mpp__fill_var_name
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This subroutine read variable value
@@ -547,28 +412,26 @@
    !>
    !> @details
-   !> If domain is given, read only domain.
-   !> If border is .TRUE., read only border processor
+   !> Optionally start indices and number of point to be read could be specify.
+   !> as well as East West ovelap of the global domain.
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_mpp    : mpp structure
-   !> @param[inout] td_var : variable structure
-   !> @param[in] td_dom    : domain structure
-   !> @param[in] ld_border : read only border
-   !> @return variable structure completed 
-   !
-   !> @todo
-   !> - modif en fonction dimension de la variable lu pour cas dom
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !> @date October, 2014
+   !> - use start and count array instead of domain structure.
+   !>
+   !> @param[in] td_mpp    mpp structure
+   !> @param[inout] td_var variable structure
+   !> @param[in] id_start  index in the variable from which the data values 
+   !> will be read
+   !> @param[in] id_count  number of indices selected along each dimension
+   !-------------------------------------------------------------------
    SUBROUTINE iom_mpp__read_var_value(td_mpp, td_var, &
-   &                                  td_dom, ld_border )
+   &                                  id_start, id_count )
       IMPLICIT NONE
       ! Argument      
       TYPE(TMPP),   INTENT(IN)    :: td_mpp
       TYPE(TVAR),   INTENT(INOUT) :: td_var
-      TYPE(TDOM),   INTENT(IN),   OPTIONAL :: td_dom
-      LOGICAL,      INTENT(IN),   OPTIONAL :: ld_border
+      INTEGER(i4), DIMENSION(:), INTENT(IN),   OPTIONAL :: id_start
+      INTEGER(i4), DIMENSION(:), INTENT(IN),   OPTIONAL :: id_count      
 
       ! local variable
@@ -579,9 +442,18 @@
       INTEGER(i4)                       :: il_j1p
       INTEGER(i4)                       :: il_j2p
-
-      LOGICAL                           :: ll_border
+      INTEGER(i4)                       :: il_i1
+      INTEGER(i4)                       :: il_i2
+      INTEGER(i4)                       :: il_j1
+      INTEGER(i4)                       :: il_j2
+
+      INTEGER(i4), DIMENSION(ip_maxdim) :: il_start
+      INTEGER(i4), DIMENSION(ip_maxdim) :: il_end
+      INTEGER(i4), DIMENSION(ip_maxdim) :: il_count      
+
+      INTEGER(i4), DIMENSION(ip_maxdim) :: il_strt
+      INTEGER(i4), DIMENSION(ip_maxdim) :: il_cnt      
+
+      TYPE(TATT)                        :: tl_att
       TYPE(TVAR)                        :: tl_var
-      TYPE(TMPP)                        :: tl_mpp
-      TYPE(TDOM)                        :: tl_dom
 
       ! loop indices
